using System;
using System.Diagnostics;


using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Globalization;
using System.Net.Http;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;
using System.Net.Http.Headers;
using System.Text;

namespace OSS
{
    class REST_Get_Package
    {

        internal class RESTPackage
        {
            public string id { get; set; }
            public string name { get; set; }
            public string language { get; set; }
            public string description { get; set; }
            public string status { get; set; }
            public List<RESTRole> roles { get; set; }
            public List<RESTDocument> documents { get; set; }
            public Nullable<DateTime> created { get; set; }

        }



        internal class RESTRole
        {
            public string id { get; set; }
            public string name { get; set; }
            public string type { get; set; }
            public List<RESTSigner> signers { get; set; }  
        }
        internal class RESTSigner
        {
            public string firstName { get; set; }
            public string lastName { get; set; }
            public string email { get; set; }
        }


        internal class RESTDocument
        {
            public string id { get; set; }
            public string name { get; set; }
            public int index { get; set; }
            public IList<RESTApproval> approvals { get; set; }
        }

        internal class RESTApproval
        {
            public string id { get; set; }
            public string role { get; set; }
            public IList<RESTField> fields { get; set; }
            public Nullable<DateTime> accepted { get; set; }
            public Nullable<DateTime> signed { get; set; }
            
        }

        internal class RESTField
        {
            public string id { get; set; }
            public string type { get; set; }
            public string subtype { get; set; }
            public double top { get; set; }
            public double left { get; set; }
            public double height { get; set; }
            public double width { get; set; }
            public double page { get; set; }
        }






        public static void Main(string[] args)
        {

            string apiKey = "your_api_key;
            string apiUrl = "https://sandbox.esignlive.com/api";
            string packageId = "-4rXEb1NGKz0vuZt714o8JevW3Y=";

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Add("Authorization", "Basic " + apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");
            var response = myClient.GetAsync(new Uri(apiUrl + $"/packages/{packageId}")).Result;
            
            if (!response.IsSuccessStatusCode)
            {
                throw new Exception(response.Content.ReadAsStringAsync().Result);
            }

            RESTPackage restPackage = JsonConvert.DeserializeObject<RESTPackage>(response.Content.ReadAsStringAsync().Result, new JsonSerializerSettings
            {
                NullValueHandling = NullValueHandling.Ignore,
                MissingMemberHandling = MissingMemberHandling.Ignore
            });


            foreach (var RestDoc in restPackage.documents) {
                foreach (var RestSignature in RestDoc.approvals)
                {
                    Debug.WriteLine($"package id: {packageId}; document id: {RestDoc.id}; signature id: {RestSignature.id}");
                    Debug.WriteLine($"role id: {RestSignature.role}; confirm date: {RestSignature.signed}; ");
                }
            }
        }



    }
}